**PROGRAM TO REPLICATE FIGURE 1 FROM IMBENS (2003) 
**Imbens, G. 2003. "Sensitivity to Exogeneity Assumptions in Program Evaluation", The American Economic Review 93(2):126-132


cd "[PUT YOUR DIRECTORY HERE]"
use "lalonde data.dta"

rename re78 targ
sensitiveJM targ t black age married hisp educ re74 reo74 re75 reo75 ,  modei eq1max(10000) eq1min(-10000) eq2max(10) eq2min(-10)  
matrix sv_mat = e(res)

sensitiveJM targ t black age married hisp educ re74 reo74 re75 reo75 , modev r2Winit( .0339832 ) r2Yinit(.0582233) eq1max(10000) eq1min(-10000) eq2max(10) eq2min(-10)  
matrix sv_mat = sv_mat \ e(res)

sensitiveJM targ t black age married hisp educ re74 reo74 re75 reo75, modev r2Winit( .0339832 ) r2Yinit(.0582233) group(re74 reo74 re75 reo75) eq1max(10000) eq1min(-10000) eq2max(10) eq2min(-10) 
matrix sv_mat = sv_mat \ e(res)


***The alpha-deta pairs that will reduce the effect estimate by $1000 are pre-specified below.
***In practice identifying these alpha-delta pairs that have a certain affect on beta may be 
***the most difficult part of the analysis.

matrix points = 0.50279853, 8502.1953 \0.6450885, 6478.3214 \0.9534333, 4353.1752 \1.2617781, 3333.822 \1.7271499, 2511.0906 \2.1572981, 2084.7482 \2.5881854, 1813.5855 \3.042803, 1623.1488 
local n = rowsof(points)
forval j = 1(1)`n' {
	local x = points[`j',1]
	local y = points[`j',2]
	sensitiveJM targ t black age married hisp educ re74 reo74 re75 reo75, modea alpha(`x') delta(`y') r2Winit( .0339832 ) r2Yinit(.0582233) eq1max(10000) eq1min(-10000) eq2max(10) eq2min(-10) 
	matrix sv_mat = sv_mat \ e(res)
}
matrix list sv_mat
svmat sv_mat, names(col)

matrix plotvar = J(1,1,0), J(1,1,0), J(1,1,0) \ J(9,1,1),  J(9,1,0),  J(9,1,0) \ J(1,1,0) , J(1,1,1) , J(1,1,0) \J(8,1,0) ,J(8,1,0), J(8,1,1)
svmat plotvar
scatter r2Y_partial r2W_partial if plotvar1 , legend(off) xscale(range(0 0.6)) yscale(range(0 .2)) || scatter r2Y_partial r2W_partial if plotvar2 || scatter r2Y_partial r2W_partial if plotvar3  , connect(l)



