program define get_partials ,  eclass

	syntax varlist [fweight pweight iweight aweight]  [if], [linlin loglog y2(string) eq1max(real 9999) eq1min(real 9999) eq2max(real 9999) eq3max(real 9999) eq3min(real 9999) eq2min(real 9999) ] alpha(real) delta(real) r2Winit(real) r2Yinit(real) y(string) b(string)

	tempname r2Y r2Y_par  r2W r2W_par
	tempname beta JM_eq_b epX tmp


	if (`eq1max'!=9999 & `eq1min'!=9999){
		local eq1txt = "eq1 `eq1min' `eq1max'"
	}
	if (`eq2max'!=9999 & `eq2min'!=9999){
		local eq2txt = "eq2 `eq2min' `eq2max'"
	}
	if (`eq3max'!=9999 & `eq3min'!=9999) {
		local eq3txt = "sigma `eq3min' `eq3max'"
	}




	if ("`linlin'"=="linlin") {
		tokenize "`varlist'"
		matrix `beta' =`b'

		local upr=colsof( `beta' )
		quietly summ `y2' [`weight' `exp'] `if'
		*local tmper = `beta'[1,`upr']
		*display "tmper is `tmper'"

		scalar `r2W' = 1 - (`beta'[1,`upr']^2)/ ( r(sd)^2 * (r(N)-1)/r(N))
		scalar `r2W_par' = ( `r2W' -`r2Winit' ) / (1-`r2Winit' )

		local upr=colsof(`beta')-1	
		quietly summ `y' [`weight' `exp'] `if'
		*local tmper = `beta'[1,`upr']
		scalar `r2Y' = 1 - (`beta'[1,`upr']^2)/ ( r(sd)^2 * (r(N)-1)/r(N))
		scalar `r2Y_par' = ( `r2Y' -`r2Yinit' ) / (1-`r2Yinit' )

	}
	else if ("`loglog'" =="loglog") {
		matrix `beta' =`b'
		local upr=colsof( `beta' )-1 
		local lwr=round((colsof( `beta' ) )/2)+1
		matrix `JM_eq_b' = `beta'[1, `lwr'..`upr' ]
		*matrix list `JM_eq_b'

		quietly corr  `varlist' [`weight' `exp'] `if' , covar
		matrix `epX' = r(C) * (r(N)-1) / r(N)
		*quietly summ `y'
		*matrix list `epX'
		matrix `tmp' = `JM_eq_b' * `epX' * `JM_eq_b''

		scalar `r2W' = (`tmp'[1,1]+(( `alpha' )^2)/4)/(`tmp'[1,1]+(( `alpha' )^2)/4+(3.14159265358979^2)/3)
		scalar `r2W_par' = ( `r2W' -`r2Winit' ) / (1-`r2Winit' )

		local upr=round((colsof( `beta' ) )/2)-1
		local lwr=1
		matrix `JM_eq_b' = `beta'[1, `lwr'..`upr' ]
		*matrix list `JM_eq_b'

		quietly corr `y2' `varlist' [`weight' `exp'] `if' , covar
		matrix `epX' = r(C) * (r(N)-1) / r(N)
		*quietly summ `y'
		*matrix list `epX'
		matrix `tmp' = `JM_eq_b' * `epX' * `JM_eq_b''

		scalar `r2Y' = (`tmp'[1,1]+(( `delta' )^2)/4)/(`tmp'[1,1]+(( `delta' )^2)/4+(3.14159265358979^2)/3)
		scalar `r2Y_par' = ( `r2Y' -`r2Yinit' ) / (1-`r2Yinit' )

	}
	else {
		matrix `beta' =`b'
		local upr=colsof( `beta' )-2 
		local lwr=round((1+colsof( `beta' ) )/2)
		matrix `JM_eq_b' = 	`beta'[1, `lwr'..`upr' ]
		*matrix list `JM_eq_b'

		quietly corr `varlist' [`weight' `exp'] `if' , covar
		*quietly summ `y'
		matrix `epX' = r(C) * (r(N)-1) / r(N)
		*matrix list `epX'
		matrix `tmp' = `JM_eq_b' * `epX' * `JM_eq_b''

		scalar `r2W' = (`tmp'[1,1]+(( `alpha' )^2)/4)/(`tmp'[1,1]+(( `alpha' )^2)/4+(3.14159265358979^2)/3)
		scalar `r2W_par' = ( `r2W' -`r2Winit' ) / (1-`r2Winit' )

		local upr=colsof(`beta')	
		local tmp222 = `beta'[1, `upr' ]
		display "tmp222 = `tmp222'"

		*ml model lf mlsensitive_v2_lf (eq1: `y' = ) (eq2: `y2' = ) ( sigma:) [`weight' `exp'] `if' 
		*ml search `eq1txt' `eq2txt' `eq3txt'
		*ml maximize `itlimit_txt'
		*local ysd = _b[sigma:_cons]
		*display "ml ysd is `ysd' " 

		quietly summ `y' [`weight' `exp'] `if'
		*display "sd of y is " r(sd)
		*display "r(sd) = " r(sd) " and r(N) = " r(N)
		scalar `r2Y'=1-( `tmp222' ^2) / ( r(sd)^2 * (r(N)-1)/r(N))
		*the term (r(N)-1)/r(N) transforms r(V) from the unbiased estimat of Var to the MLE
		scalar `r2Y_par' = ( `r2Y'- `r2Yinit' ) / (1- `r2Yinit' )
		*local fu=1-( `tmp222' ^2)/ ( _b[sigma:_cons]^2 )
		*display "scalar(r2Y)=" scalar(`r2Y') "  fu = `fu'" 


	}

	ereturn scalar r2Y_init = `r2Y'
	ereturn scalar r2W_init = `r2W'
	ereturn scalar r2Y_par = `r2Y_par'
	ereturn scalar r2W_par = `r2W_par'
	
end 


