program define mlsensitive_v2_lf

	args lnf beta lambda sigma

	tempvar lin log lin2 log2 lnfj 
	quietly gen double `lin' = (1/(`sigma'*(2*3.14159265358979)^.5))*exp((-1/(2*`sigma'^2))*($ML_y1-`beta'     )^2)
	quietly gen double `lin2'= (1/(`sigma'*(2*3.14159265358979)^.5))*exp((-1/(2*`sigma'^2))*($ML_y1-`beta'-scalar(JM_delta))^2)

	quietly gen double `log'  =  exp(`lambda'              )/(1+exp(`lambda'               )) if $ML_y2==1
	quietly replace    `log'  =                            1/(1+exp(`lambda'	       )) if $ML_y2==0
	quietly gen double `log2' =  exp(`lambda'+scalar(JM_alpha))/(1+exp(`lambda'+scalar(JM_alpha) )) if $ML_y2==1
	quietly replace    `log2' =                            1/(1+exp(`lambda'+scalar(JM_alpha) )) if $ML_y2==0
	

	quietly summarize `lin' `lin2' `log' `log2'
	quietly gen double `lnfj'=  ln(0.5*`log'*`lin' + 0.5*`log2'*`lin2')
	quietly replace `lnf' = `lnfj'

	if ($ML_ic-1+1==$it_limit_num){
		display "*****convergence not achieved"
		scalar notconverged=1
		exit
	}

end
