program define mlsensitive_v2_lf_loglog

	args lnf beta lambda

	tempvar lin log lin2 log2 lnfj 

	quietly gen double `lin'  =  exp(`beta'              )/(1+exp(`beta'               )) if $ML_y1==1
	quietly replace    `lin'  =                            1/(1+exp(`beta'	       )) if $ML_y1==0
	quietly gen double `lin2' =  exp(`beta'-scalar(JM_delta))/(1+exp(`beta'-scalar(JM_delta) )) if $ML_y1==1
	quietly replace    `lin2' =                            1/(1+exp(`beta'-scalar(JM_delta) )) if $ML_y1==0
	

	quietly gen double `log'  =  exp(`lambda'              )/(1+exp(`lambda'               )) if $ML_y2==1
	quietly replace    `log'  =                            1/(1+exp(`lambda'	       )) if $ML_y2==0
	quietly gen double `log2' =  exp(`lambda'+scalar(JM_alpha))/(1+exp(`lambda'+scalar(JM_alpha) )) if $ML_y2==1
	quietly replace    `log2' =                            1/(1+exp(`lambda'+scalar(JM_alpha) )) if $ML_y2==0
	

	quietly summarize `lin' `lin2' `log' `log2'
	quietly gen double `lnfj'=  ln(0.5*`log'*`lin' + 0.5*`log2'*`lin2')
	quietly replace `lnf' = `lnfj'

	if ($ML_ic-1+1==$it_limit_num){
		display "*****convergence not achieved"
		scalar notconverged=1
		exit
	}

end
