program define sensitiveJM , eclass

	syntax varlist(min=3) [ pweight iweight aweight fweight ] [if] [, MODEInit MODEVarpartials MODEAlphadelta loglog linlin alpha(real 0) delta(real 0) r2Winit(real 0) r2Yinit(real 0) itlimit(integer 100) eq1max(real 9999) eq1min(real 9999) eq2max(real 9999) eq2min(real 9999) eq3min(real 9999) eq3max(real 9999) group(string)]
	ereturn clear

	*display " [`weight' `exp' ] "
	*display "if is `if'"


	if ("`modeinit'"=="" & "`modevarpartials'"=="" & "`modealphadelta'"=="") {
		local modeinit = "modeinit"
		local modevarpartials = "modevarpartials"
		if(`alpha'!=0 | `delta'!=0) {
			local modealphadelta = "modealphadelta"
		}
	} 
	
	display "*TEST FOR MISSING VALUES HERE"



	*PARSE VARIABLES
	local count = 0
	*display "varlist is `varlist'"
	*display "group is `group'"
	tokenize `group'
	tempname JM_filt
	quietly gen `JM_filt' = 1
	*summarize `JM_filt'
	*display "1 is |`1'| 2 is |`2'| 3 is |`3'|"
	foreach v in `varlist' {
		local count=`count'+1
		local v`count'="`v'"
		*display "v`count'= `v`count''"
		if `count' >=3 {
			local indep = "`indep' `v`count''"
		}
		quietly replace `JM_filt'=0 if `v`count'' ==.
	}



	if("`linlin'"=="linlin" || "`loglog'"=="loglog" ) {
		local opty2 = " y2(`v2') "
	}



	tempname vars
	tempname be Ve  binit Vinit


	*INITIALIZE MODEL
	if ("`modeinit'"=="modeinit") {
		scalar JM_alpha = 0
		scalar JM_delta = 0

		mata: printf("{txt}INITIAL MODEL {c |} alpha={res}0 {txt}delta={res}0\n")
		callmodelJM `varlist' [`weight' `exp' ]  `if' , `linlin'  `loglog' itlimit(`itlimit') eq1min(`eq1min') eq1max(`eq1max') eq2min(`eq2min') eq2max(`eq2max') eq3max(`eq3max') eq3min(`eq3min')
		get_partials `indep' `if' , `linlin' `loglog' `opty2' alpha(0) delta(0) r2Winit(0) r2Yinit(0) b(e(b)) y(`v1') y2(`v2') eq1min(`eq1min') eq1max(`eq1max') eq2min(`eq2min') eq2max(`eq2max') eq3max(`eq3max') eq3min(`eq3min')
		local r2Winit = e(r2W_par)
		local r2Yinit = e(r2Y_par)
		matrix `binit'=e(b)
		matrix `Vinit' = e(V)
		scalar initbet = `binit'[1,1]
		local initbet = scalar(initbet)

		ereturn matrix b_init = `binit'
		ereturn matrix V_init = `Vinit'

		matrix `vars' = nullmat(`vars')\ 0, 0, e(r2W_init), e(r2Y_init), ., ., `initbet'
		local rnames= "Initial_model"


	}

	*display "r2Winit is `r2Winit'  and  r2Yinit is `r2Yinit'"

	*matrix list `vars'


	if("`modevarpartials'"=="modevarpartials") {
		scalar JM_alpha = 0
		scalar JM_delta = 0
		if ("`group'"==""){
			forval i=3(1)`count' {
				local vs = ""
				forval j = 3(1)`count' {
					if (`i' != `j'){
						local vs = "`vs' `v`j''"
						*display "`vs'"
					}
				}	
				callmodelJM `v1' `v2' `vs'  [`weight' `exp' ] `if' , `linlin' `loglog' itlimit(`itlimit') eq1min(`eq1min') eq1max(`eq1max') eq2min(`eq2min') eq2max(`eq2max')
				*display "r2Winit is `r2Winit'  and  r2Yinit is `r2Yinit'"

				get_partials `vs'  `if', `linlin' `loglog'  `opty2' alpha(0) delta(0) r2Winit(0) r2Yinit(0) b(e(b)) y(`v1') y2(`v2') eq1min(`eq1min') eq1max(`eq1max') eq2min(`eq2min') eq2max(`eq2max') eq3max(`eq3max') eq3min(`eq3min')
				*display "get_partials returns" e(r2Y_init) " " e(r2W_init) " " e(r2Y_par) " " e(r2W_par)
				*display "r2Winit is `r2Winit'  and  r2Yinit is `r2Yinit'"

				matrix `be'=e(b)
				scalar varbet = `be'[1,1]
				scalar tmpW = ( `r2Winit' -e(r2W_init) ) / ( 1-e(r2W_init) )
				scalar tmpY = ( `r2Yinit'  -e(r2Y_init) ) / (1-e(r2Y_init) )
				*display "tmp is " scalar(tmpW) " and " scalar(tmpY)
				matrix `vars' = nullmat(`vars')\ 0, 0 , e(r2W_init), e(r2Y_init), scalar(tmpW), scalar(tmpY), scalar(varbet)
				local rnames="`rnames' `v`i''"
			}
		}
		else {
			local vs = ""
			forval i=3(1)`count' {
				local c`i'="`v`i''"
				forval j = 1(1)`count' {
					if ("`v`i''" == "``j''"){
						local tmprnames="`tmprnames'`c`i''_"
						local c`i' = ""
						*display "c`i' is `c`i''"
					}
				}	
				local vs = "`vs' `c`i''"
			}

			callmodelJM `v1' `v2' `vs'  [`weight' `exp' ]  `if'  , `linlin' `loglog'  itlimit(`itlimit') eq1min(`eq1min') eq1max(`eq1max') eq2min(`eq2min') eq2max(`eq2max')
			*display "r2Winit is `r2Winit'  and  r2Yinit is `r2Yinit'"
			get_partials `vs'  `if', `linlin' `loglog'  `opty2' alpha(0) delta(0) r2Winit(0) r2Yinit(0) b(e(b)) y(`v1') y2(`v2') eq1min(`eq1min') eq1max(`eq1max') eq2min(`eq2min') eq2max(`eq2max') eq3max(`eq3max') eq3min(`eq3min')
			*display "get_partials returns e(r2Y_init) e(r2W_init) e(r2Y_par) e(r2W_par)

			matrix `be'=e(b)
			scalar varbet = `be'[1,1]
			scalar tmpW = ( `r2Winit' -e(r2W_init) ) / ( 1-e(r2W_init) )
			scalar tmpY = ( `r2Yinit'  -e(r2Y_init) ) / (1-e(r2Y_init) )
			matrix `vars' = nullmat(`vars')\ 0, 0 , e(r2W_init), e(r2Y_init), scalar(tmpW), scalar(tmpY), scalar(varbet)
			local rnames = "`rnames' var_group"
			display "rnames is `rnames'"

		}

		*matrix list `vars'
		*ereturn matrix varpartials = `vars'
	}

	*matrix list `vars'


	*RUN MODEL
	if ("`modealphadelta'"=="modealphadelta") {
		scalar JM_alpha = `alpha'
		scalar JM_delta = `delta'
		*scalar dir
		mata: printf("{txt}COMPARISON MODEL {c |} alpha={res}`alpha' {txt}delta={res}`delta'\n")
		callmodelJM `varlist'  [`weight' `exp' ] `if'  , `linlin' `loglog'  itlimit(`itlimit') eq1min(`eq1min') eq1max(`eq1max') eq2min(`eq2min') eq2max(`eq2max')
		*display  "r2Winit is `r2Winit'"
		get_partials `indep'  `if', `linlin' `loglog'  `opty2' alpha(`alpha') delta(`delta')  r2Winit(`r2Winit') r2Yinit(`r2Yinit') b(e(b)) y(`v1') y2(`v2') eq1min(`eq1min') eq1max(`eq1max') eq2min(`eq2min') eq2max(`eq2max') eq3max(`eq3max') eq3min(`eq3min')
		tempname r2Wpar r2Ypar 
		local r2Winit=e(r2W_init)
		local r2Yinit=e(r2Y_init)
		local r2Wpar=e(r2W_par)
		local r2Ypar=e(r2Y_par)

		tempname b V
		matrix `b' = e(b)
		matrix `V' = e(V)
		local comparebet = `b'[1,1]

		matrix `vars' = nullmat(`vars')\ `alpha', `delta', e(r2W_init), e(r2Y_init), e(r2W_par), e(r2Y_par), `comparebet'
		local rnames="`rnames' alpha-delta"


	}

	*display "row names are `rnames'"
	matrix rownames `vars' = `rnames' 
	matrix colnames `vars' = alpha delta r2W r2Y r2W_partial r2Y_partial b
	*matrix list `vars'

	***PRINTOUT****
	mata: printf("\n\n\n{txt}{hline 13}{c +}{hline 70}\n{space 13}{c |}     alpha     delta      r2W       r2Y     r2Wpar    r2Ypar       b\n{hline 13}{c +}{hline 70}\n")

	local c = rowsof(`vars')
	tokenize "`rnames'"

	forval i = 1(1)`c' {
	
		local r1=`vars'[`i',1]
		local r2= `vars'[`i',2]  
		local r3 = `vars'[`i',3]  
		local r4 = `vars'[`i',4] 
		local r5 = `vars'[`i',5]
		local r6 = `vars'[`i',6]
		local r7 = `vars'[`i',7]

		mata: printf("{txt}%13s{c |}{res}%9.0g %9.0g %9.0g %9.0g %9.0g %9.0g %9.0g\n", "``i''" , `r1', `r2', `r3', `r4', `r5', `r6', `r7')
	}


	mata: printf("\n\n\n")

	ereturn matrix res = `vars'
	scalar drop JM_alpha JM_delta

end

